## bacula 15.0.3

=== platforms/osx/Makefile ===
#
# Copyright (C) 2000-2023 Kern Sibbald
# License: BSD 2-Clause; see file LICENSE-FOSS
#
# This is the makefile template for the platform directory
# which contains general platform installation.
#
#  17 August 2009 -- Lorenz Schori
#  29 Jun    2022 -- Eric Bollengier
# 
#   for Bacula 
#


# bacula version and download site
BACULA_VERSION ?= $(shell ../../scripts/getver ../../src/version.h)

SWIFT_APP_GIT ?= git@bsweb:macosx
SWIFT_APP_BRANCH ?= master

OPENSSL_VERSION_BASE ?= 1.1.1
OPENSSL_VERSION=$(shell curl https://www.openssl.org/source/ 2>/dev/null| perl -ne '/openssl-(${OPENSSL_VERSION_BASE}[a-z]+).tar.gz/ && print $$1')
OPENSSL_DL_URL:=https://www.openssl.org/source/openssl-${OPENSSL_VERSION}.tar.gz

LZO_VERSION=2.10
LZO_DL_URL=https://www.oberhumer.com/opensource/lzo/download/lzo-${LZO_VERSION}.tar.gz

# Build universal binary. Comment out when building versions of bacula < 3.0.0
ARCHFLAGS:=
MACOSX_SDK_SYSROOT:=
MACOSX_VERSION_FLAGS:=

# Tools
PB:=/usr/bin/pkgbuild
MAKE:=/usr/bin/make
CURL:=/usr/bin/curl
TAR:=/usr/bin/tar

########### you should not have to edit anything beyond this line ###########

# Build paths
DL_DIR:=dl
BUILD_DIR:=build
PRODUCTS_DIR:=products

# Can source ~/config to have all it set
# To unlock the security, use security unlock

# "Developer ID Application: Bacula YYYY (XXX)"
BIN_KEY ?= "Must specify BIN_KEY='Developer ID Application: Bacula YYYY (XXX)'"

# "Developer ID Installer: Bacula YYYY (XXXX)"
PRODUCT_KEY ?= "Must specify PRODUCT_KEY='Developer ID Installer: Bacula YYYY (XXXX)'"

APPLEID_USER ?= "Must specify APPLEID_USER='test@bacula.org'"
APPLEID_APP_PASS ?= "Must specify APPLEID_APP_PASS='xxx'"

WORKING_DIR:=${BUILD_DIR}
BACULA_TAR:=${DL_DIR}/bacula-${BACULA_VERSION}.tar.gz
BACULA_SOURCE:=${WORKING_DIR}/bacula-${BACULA_VERSION}
BACULA_DESTDIR:=${WORKING_DIR}/destdir
BACULA_PREFIX:=/Applications/Bacula.app/Contents/Resources/BaculaBin
BACULA_FD_CONF:=/Library/Preferences/bacula/bacula-fd.conf
BACULA_WORKING_DIR:=/private/var/bacula/working
BACULA_PMDOC:=${WORKING_DIR}/installer.pmdoc

# Detect whether we sit inside the Bacula source tree. In this case we won't
# download the tar from sourceforge but instead work with what is there
# already
CURSUB:=$(CURDIR:%/platforms/osx=%)
ifneq ($(CURDIR),$(CURSUB))
	BACULA_TAR:=
	BACULA_SOURCE:=../../
endif

NOW=$(shell date +%d%h%y-%H%M)

PACKAGE_TITLE:=bacula-client-${BACULA_VERSION}-${NOW}
PACKAGE_BASE:=org.bacula
PACKAGE_ID:=${PACKAGE_BASE}.bacula-fd.pkg
PACKAGE_DIR:=${PRODUCTS_DIR}/${PACKAGE_TITLE}
PACKAGE_BUNDLE:=${PACKAGE_DIR}/${PACKAGE_TITLE}.pkg
PACKAGE_DMG:=${PRODUCTS_DIR}/${PACKAGE_TITLE}.dmg
PACKAGE_RESOURCES:=ReadMe.html postflight preupgrade
PACKAGE_XRESOURCES:=postflight preupgrade

# Flags for the toolchain
CONFIGFLAGS:= \
  --enable-client-only \
  --prefix=${BACULA_PREFIX} \
  --with-dir-password=@DIR_PW@ \
  --with-fd-password=@FD_PW@ \
  --with-sd-password=@SD_PW@ \
  --with-mon-dir-password=@MON_DIR_PW@ \
  --with-mon-fd-password=@MON_FD_PW@ \
  --with-mon-sd-password=@MON_SD_PW@ \
  --with-basename=@BASENAME@ \
  --with-hostname=@HOSTNAME@ \
  --with-working-dir=@CONTAINER_PATH@ \
  --with-pid-dir=@CONTAINER_PATH@ \
  --with-openssl=${PWD}/openssl \
  --with-lzo=${PWD}/lzo
CPPFLAGS:=
CFLAGS:=-O -g
CXXFLAGS:=${CFLAGS}
LDFLAGS:=-framework CoreFoundation

# required on snow leopard: compiling for 10.4 requires usage of gcc 4.0
# system defaults to version 4.2
CC:=gcc
CPP:=cpp
CXX:=g++
CXXPP:=cpp

# Placeholders for *.in files
INFILE_SUBST=\
  -e "s,@PACKAGE_BASE@,${PACKAGE_BASE},g" \
  -e "s,@PREFIX@,${BACULA_PREFIX},g" \
  -e "s,@BACULA_VERSION@,${BACULA_VERSION},g" \
  -e "s,@FD_CONF@,${BACULA_FD_CONF},g" \
  -e "s,@BACULA_DESTDIR@,${BACULA_DESTDIR},g" \
  -e "s,@PACKAGE_ID@,${PACKAGE_ID},g"

all: sign-fd ${PACKAGE_TITLE}.pkg notarize-pkg

clean-fd:
	rm -rf ${CURDIR}/${BACULA_DESTDIR}

install-fd: clean-fd build-fd
	${MAKE} -C ${BACULA_SOURCE} install DESTDIR="${CURDIR}/${BACULA_DESTDIR}"
	${MAKE} -C ${BACULA_SOURCE}/src/tools install-bsnapshot DESTDIR="${CURDIR}/${BACULA_DESTDIR}"
	cp lzo/lib/*.dylib ${CURDIR}/${BACULA_DESTDIR}/${BACULA_PREFIX}/lib
	cp lzo/share/doc/lzo/COPYING ${CURDIR}/${BACULA_DESTDIR}/${BACULA_PREFIX}/share/doc/COPYING.lzo
	cp openssl/lib/*.dylib ${CURDIR}/${BACULA_DESTDIR}/${BACULA_PREFIX}/lib
	cp -r openssl/lib/engines* ${CURDIR}/${BACULA_DESTDIR}/${BACULA_PREFIX}/lib
	cp -r openssl/ssl ${CURDIR}/${BACULA_DESTDIR}/${BACULA_PREFIX}/
	cp -r openssl/bin/* ${CURDIR}/${BACULA_DESTDIR}/${BACULA_PREFIX}/sbin/
	cp -r openssl/bin/* ${CURDIR}/${BACULA_DESTDIR}/${BACULA_PREFIX}/sbin/
	chmod 755 ${CURDIR}/${BACULA_DESTDIR}/${BACULA_PREFIX}/sbin/*
	chmod 644 ${CURDIR}/${BACULA_DESTDIR}/${BACULA_PREFIX}/lib/*.dylib
	chmod 755 ${CURDIR}/${BACULA_DESTDIR}/${BACULA_PREFIX}/etc
	rm -rf "${BACULA_DESTDIR}/tmp"
	rm -rf "${BACULA_DESTDIR}/opt"
	rm -rf "${BACULA_DESTDIR}/private"
	rm -rf "${BACULA_DESTDIR}/usr"

	for conffile in ${BACULA_DESTDIR}${BACULA_PREFIX}/etc/*.conf; do \
		mv $$conffile $$conffile.example; \
	done

	chmod 644 ${CURDIR}/${BACULA_DESTDIR}/${BACULA_PREFIX}/etc/*.example

	mkdir -p "${BACULA_DESTDIR}${BACULA_PREFIX}/Library/LaunchDaemons"
	sed ${INFILE_SUBST} files/bacula-fd.plist.in \
		> "${BACULA_DESTDIR}${BACULA_PREFIX}/Library/LaunchDaemons/${PACKAGE_BASE}.bacula-fd.plist"

	mkdir -p "${BACULA_PMDOC}"
	for f in index.xml 01destdir.xml; do \
		sed ${INFILE_SUBST} \
			files/installer.pmdoc.in/$$f > "${BACULA_PMDOC}/$$f"; \
	done

	mkdir -p "${WORKING_DIR}/resources"

	for res in ${PACKAGE_RESOURCES}; do \
		sed ${INFILE_SUBST} \
			resources/$$res.in > "${WORKING_DIR}/resources/$$res"; \
	done

	for xres in ${PACKAGE_XRESOURCES}; do \
		chmod +x "${WORKING_DIR}/resources/$$xres"; \
	done

	cp "${BACULA_SOURCE}/LICENSE" "${WORKING_DIR}/resources/License.txt"


dmg: pkg
	rm -rf "${PACKAGE_DIR}"
	mkdir -p "${PACKAGE_DIR}"
	cp ${PACKAGE_TITLE}.pkg "${PACKAGE_DIR}"
	cp ${WORKING_DIR}/resources/ReadMe.html "${PACKAGE_DIR}/ReadMe.html"

	sed ${INFILE_SUBST} \
		files/uninstall.command.in > "${PACKAGE_DIR}/uninstall.command";
	chmod 0775 "${PACKAGE_DIR}/uninstall.command"

	hdiutil create -srcfolder "${PACKAGE_DIR}" "${PACKAGE_DMG}"

pkg: setup-pkg sign-pkg notarize-pkg

notarize-pkg: ${PACKAGE_TITLE}.pkg
	@echo "Sending the notarize request to Apple"
	xcrun altool --notarize-app --file $< --username $(APPLEID_USER) --password $(APPLEID_APP_PASS) --primary-bundle-id "${PACKAGE_BASE}.pkg" > 1
	@cat 1
	./wait-notarize 1

${PACKAGE_TITLE}.unsigned.pkg:
	${PB} --identifier "${PACKAGE_ID}" --version ${BACULA_VERSION} --install-location /Applications --root "${BACULA_DESTDIR}/Applications" ${PACKAGE_TITLE}.unsigned.pkg

sign-pkg: ${PACKAGE_TITLE}.pkg

${PACKAGE_TITLE}.pkg: ${PACKAGE_TITLE}.unsigned.pkg
	productsign --sign  "$(PRODUCT_KEY)" ${PACKAGE_TITLE}.unsigned.pkg ${PACKAGE_TITLE}.pkg
	rm ${PACKAGE_TITLE}.unsigned.pkg
	echo ${PACKAGE_TITLE}.pkg

sign-fd:  install-fd
	for binfile in ${BACULA_DESTDIR}${BACULA_PREFIX}/sbin/* ${BACULA_DESTDIR}${BACULA_PREFIX}/lib/*dylib ${BACULA_DESTDIR}${BACULA_PREFIX}/lib/*/*dylib ${BACULA_DESTDIR}${BACULA_PREFIX}/lib/*.so ; do \
		./update-libs ${BACULA_PREFIX} $$binfile ;\
		codesign  -v --force --timestamp --options=runtime --sign "$(BIN_KEY)" $$binfile; \
	done

build-fd: configure-fd
	make -C ${BACULA_SOURCE}

configure-fd: openssl lzo ${BACULA_SOURCE}/configure
	(cd ${BACULA_SOURCE} && ./configure ${CONFIGFLAGS} CPPFLAGS="${CPPFLAGS}" CFLAGS="${CFLAGS}" CXXFLAGS="${CXXFLAGS}" LDFLAGS="${LDFLAGS}" CC="${CC}" CPP="${CPP}" CXX="${CXX}" CXXPP="${CXXPP}")
	grep " TLS support:" ${BACULA_SOURCE}/config.out | grep yes
	grep "Encryption support:" ${BACULA_SOURCE}/config.out | grep yes
	touch $@

lzo-${LZO_VERSION}.tar.gz:
	@echo "Download LZO ${LZO_VERSION}"
	${CURL} --output $@ ${LZO_DL_URL}

lzo-${LZO_VERSION}: lzo-${LZO_VERSION}.tar.gz
	tar xfz $< 

lzo: lzo-${LZO_VERSION} lzo-${LZO_VERSION}/Makefile
	rm -rf lzo
	make -j3 -C lzo-${LZO_VERSION}
	make -j3 -C lzo-${LZO_VERSION} install

lzo-${LZO_VERSION}/Makefile:
	(cd lzo-${LZO_VERSION} && ./configure --prefix=${PWD}/lzo --enable-shared)

openssl-${OPENSSL_VERSION}.tar.gz:
	@echo "Download ${OPENSSL_VERSION}"
	${CURL} --output $@ ${OPENSSL_DL_URL}

openssl-${OPENSSL_VERSION}: openssl-${OPENSSL_VERSION}.tar.gz
	tar xfz $< 

openssl: openssl-${OPENSSL_VERSION} openssl-${OPENSSL_VERSION}/Makefile
	rm -rf openssl
	make -j4 -C openssl-${OPENSSL_VERSION}
	make -j4 -C openssl-${OPENSSL_VERSION} install

openssl-${OPENSSL_VERSION}/Makefile:
	(cd openssl-${OPENSSL_VERSION} && ./config --prefix=${PWD}/openssl)

################################################################

unlock:
	security unlock

.PHONY: distclean
distclean: clean
	rm -rf build
	make -C ../../ distclean

.PHONY: clean cleanup
clean:
	rm -rf *.pkg *.dmg 1 products sign-pkg pkg check-pkg setup-swift-app configure-fd pkg Applications

cleanup:
	make -C ../../ clean

=== scripts/kubernetes-bacula-backup/Makefile ===
#
# Simple Makefile for building plugins for Bacula
#
# Copyright (C) 2000-2023 Kern Sibbald
# License: BSD 2-Clause; see file LICENSE-FOSS
#
# The script creates a docker image of the baculatar.py
# program. It uses also a static version of tar.
#
# It requires docker and pyinstaller (installed via pip3)
# The reference platform is bionic
#
D=$(shell date +%d%b%y)
all: bacula-backup-$(D).tar.gz

bacula-backup-$(D).tar.gz: baculatar.py tar Dockerfile
	docker build -t bacula-backup .
	docker tag bacula-backup:latest bacula-backup:$(D)
	docker save -o bacula-backup-$(D).tar bacula-backup:$(D)
	gzip -9 bacula-backup-$(D).tar

baculatar: baculatar.py
	pyinstaller baculatar.py
	./copylibs dist/baculatar/libpython*
	rm -rf dist build
	pyinstaller -F baculatar.py
	mv -f dist/baculatar .
	./copylibs baculatar

tar:
	rm -rf archbuild
	git clone https://github.com/ebl/tar-static.git archbuild
	(cd archbuild; ./build.sh)
	cp archbuild/releases/tar .
	rm -rf archbuild

clean:
	rm -rf baculatar.c bacula-backup-*.tar.gz __pycache__ baculatar.spec
	rm -rf dist build baculatar libs

distclean: clean
	rm -f tar

upload: bacula-backup-$(D).tar.gz
	rsync -avz bacula-backup-$(D).tar.gz bacula.org:/home/src/depkgs/

=== scripts/kubernetes-bacula-backup/requirements.txt ===
# -*- coding: UTF-8 -*-
# Copyright (C) 2000-2020 Kern Sibbald
# License: BSD 2-Clause; see file LICENSE-FOSS
#
#     Author: Radoslaw Korzeniewski, radekk@inteos.pl, Inteos Sp. z o.o.
#
pyinstaller

=== src/plugins/Makefile ===
#
# Simple Makefile for building test plugins for Bacula
#
# Copyright (C) 2000-2023 Kern Sibbald
# License: BSD 2-Clause; see file LICENSE-FOSS
#

first_rule: all
dummy:

all: dir fd sd

dir:	dummy
	(cd dir && make DESTDIR=$(DESTDIR) || exit 1)
	@echo

fd:	dummy
	(cd fd && make DESTDIR=$(DESTDIR) || exit 1)
	@echo

sd:	dummy
	(cd sd && make DESTDIR=$(DESTDIR) || exit 1)
	@echo


clean:
	(cd dir && make DESTDIR=$(DESTDIR) clean || exit 1)
	(cd fd && make DESTDIR=$(DESTDIR) clean || exit 1)
	(cd sd && make DESTDIR=$(DESTDIR) clean || exit 1)

=== src/win32/Makefile ===
# Copyright (C) 2000-2023 Kern Sibbald
# License: BSD 2-Clause; see file LICENSE-FOSS
#
#  Makefile for Win32/Win64 Bacula File daemon
#
#  If called make win64=yes the Win64 version will be built
#     otherwise the Win32 version will be built.
#
#  If called with bat=no, bat will not be built, otherwise it will be
#     built.
#

# ignore "make -j N" option at this level
.NOTPARALLEL:

ECHO_CMD=@

WIN32_DIRS=lib filed filed/plugins console scripts stored
WIN64_DIRS=lib filed filed/plugins console scripts stored

ifeq ($(win64),yes)
	 DIRS=$(WIN64_DIRS)
	 INSTALLER=win64_installer
	 SPECIAL=bat64 bsmtp tools
else
	 DIRS=$(WIN32_DIRS)
	 INSTALLER=win32_installer
	 SPECIAL=bat32 bsmtp tools
endif

ifeq ($(bat),no)
	 SPECIAL=bsmtp tools
endif	

.PHONY: $(DIRS) clean all Makefile.inc win32_installer full_win32_installer \
	 win64_installer bsmtp tools distclean

all: Makefile.inc $(DIRS) $(SPECIAL) $(INSTALLER)

distclean: clean

clean: $(DIRS) win32_installer win64_installer
	$(MAKE) -C tools clean
	$(ECHO_CMD)-rm -rf release32 release64
	$(ECHO_CMD)-rm -rf ../qt-console/obj32 ../qt-console/obj64 ../qt-console/ui32 ../qt-console/ui64
	$(ECHO_CMD)-rm -rf ../qt-console/release ../qt-console/debug
	$(ECHO_CMD)-rm -rf ../qt-console/tray-monitor/obj32 ../qt-console/tray-monitor/obj64 ../qt-console/tray-monitor/ui32 ../qt-console/tray-monitor/ui64
	$(ECHO_CMD)-rm -rf ../qt-console/tray-monitor/release ../qt-console/tray-monitor/debug

is_depkgs_set:
	@if test -z $${DEPKGS} ; then \
	   echo "variable DEPKGS not set" ; \
	   echo "You probably want DEPKGS=\"`(cd ../../..;pwd)`\"" ; \
	   exit 1; \
	fi ; \

release32/bat.exe: is_depkgs_set
	( cd ../qt-console; ./make-win32 "32" )
	test -f release32/bat.exe
	test -f release32/bacula-tray-monitor.exe
	./sign-binaries release32/bat.exe release32/bacula-tray-monitor.exe release32/Qt*dll release32/q*.dll

bat32: release32/bat.exe release32/bacula-tray-monitor.exe

release64/bat.exe: is_depkgs_set
	( cd ../qt-console; ./make-win32 "64" )
	test -f release64/bat.exe
	test -f release64/bacula-tray-monitor.exe
	./sign-binaries release64/bat.exe release64/bacula-tray-monitor.exe release64/Qt*dll release64/q*.dll

bat64: release64/bat.exe release64/bacula-tray-monitor.exe

# a target that quickly build windows bacula-fd.exe
winfiled:
	@for I in lib filed filed/plugins console; \
	  do (cd $$I; echo "==>Entering directory `pwd`"; \
	      $(MAKE) DESTDIR=$(DESTDIR)  || (echo ""; echo ""; echo "  ====== Error in `pwd` ======"; \
	                    echo ""; echo ""; false ) || false) || exit 1; \
	done

full_win32_installer:
	@if test -f Makefile.inc; then \
	   if $(MAKE) -C $@ $(MAKECMDGOALS); then \
		echo "\n===== Make of $@ succeeded =====\n\n" ; \
	   else  \
		echo "\n!!!!! Make of $@ failed !!!!!\n\n" ; exit 1; \
	   fi ; \
	fi

win32_installer:
	echo "Making 32 bit version"
	@if test -f Makefile.inc; then \
	   if $(MAKE) -C $@ $(MAKECMDGOALS); then \
		echo "\n===== Make of $@ succeeded =====\n\n" ; \
	   else  \
		echo "\n!!!!! Make of $@ failed !!!!!\n\n" ; exit 1; \
	   fi ; \
	fi

win64_installer:
	echo "Making 64 bit version"
	@if test -f Makefile.inc; then \
	   if $(MAKE) -C $@ $(MAKECMDGOALS); then \
		echo "\n===== Make of $@ succeeded =====\n\n" ; \
	   else  \
		echo "\n!!!!! Make of $@ failed !!!!!\n\n" ; exit 1; \
	   fi ; \
	fi


$(DIRS):
	@if test -f Makefile.inc; then \
	   if $(MAKE) -C $@ $(MAKECMDGOALS); then \
		echo "\n===== Make of $@ succeeded =====\n\n" ; \
	   else  \
		echo "\n!!!!! Make of $@ failed !!!!!\n\n" ; exit 1; \
	   fi ; \
	fi

bsmtp:
	@if test -f Makefile.inc; then \
	   if $(MAKE) -C tools bsmtp $(MAKECMDGOALS); then \
		echo "\n===== Make of tools/bsmtp succeeded =====\n\n" ; \
	   else  \
		echo "\n!!!!! Make of tools/bsmtp failed !!!!!\n\n" ; exit 1; \
	   fi ; \
	fi

tools:
	@if test -f Makefile.inc; then \
	   if $(MAKE) -C tools all $(MAKECMDGOALS); then \
		echo "\n===== Make of tools/all succeeded =====\n\n" ; \
	   else  \
		echo "\n!!!!! Make of tools/all failed !!!!!\n\n" ; exit 1; \
	   fi ; \
	fi

Makefile.inc:
	@echo Creating $@
	$(ECHO_CMD)TOPDIR=`(cd ../../..;pwd)`; \
	TOPDIR=$${DEPKGS:-$${TOPDIR}}; \
	if test "$(win64)" = yes -a -e $${TOPDIR}/cross-tools/mingw-w64/bin/x86_64-pc-mingw32-gcc; then \
		BINDIR=$${TOPDIR}/cross-tools/mingw-w64/bin; \
		INCDIR=$${TOPDIR}/cross-tools/mingw-w64/x86_64-pc-mingw32/include; \
		DLLDIR=$${TOPDIR}/cross-tools/mingw-w64/x86_64-pc-mingw32/bin; \
		DEPKGSDIR=depkgs-mingw-w64; \
		DEPKGSDIR32=depkgs-mingw32; \
		MINGWBASE=x86_64-pc-mingw32; \
	elif test -e $${TOPDIR}/cross-tools/mingw32/bin/mingw32-gcc; then \
		BINDIR=$${TOPDIR}/cross-tools/mingw32/bin; \
		INCDIR=$${TOPDIR}/cross-tools/mingw32/mingw32/include; \
		DLLDIR=$${TOPDIR}/cross-tools/mingw32/mingw32/bin; \
		DEPKGSDIR=depkgs-mingw32; \
		DEPKGSDIR32=depkgs-mingw32; \
		MINGWBASE=mingw32; \
	elif test "$(win64)" = yes && which x86_64-w64-mingw32-g++ ; then \
		BINDIR=; \
		INCDIR=; \
		DLLDIR=; \
		DEPKGSDIR=depkgs-mingw-w64; \
		DEPKGSDIR32=depkgs-mingw32; \
		MINGWBASE=x86_64-w64-mingw32; \
	elif which i686-w64-mingw32-g++ ; then \
		BINDIR=; \
		INCDIR=; \
		DLLDIR=; \
		DEPKGSDIR=depkgs-mingw32; \
		DEPKGSDIR32=depkgs-mingw32; \
		MINGWBASE=i686-w64-mingw32; \
	else \
		echo "\nThe GCC cross compiler isn't installed."; \
		echo "You must run build-win32-cross-tools and build-dependencies first.\n"; \
		exit 1; \
	fi ; \
	BUILDDIR=`(pwd)`; \
	MAINDIR=`(cd ../..;pwd)`; \
	sed \
		-e "s^@MINGWBASE@^$${MINGWBASE}^" \
		-e "s^@WIN64@^$${win64}^" \
		-e "s^@BAT@^$${bat}^" \
		-e "s^@WIN32DEPKGS@^$${DEPKGSDIR}^" \
		-e "s^@WIN32DEPKGS32@^$${DEPKGSDIR32}^" \
		-e "s^@WIN32BUILDDIR@^$${BUILDDIR}^" \
		-e "s^@WIN32MAINDIR@^$${MAINDIR}^" \
		-e "s^@WIN32TOPDIR@^$${TOPDIR}^" \
		-e "s^@WIN32BINDIR@^$${BINDIR}^" \
		-e "s^@WIN32INCDIR@^$${INCDIR}^" \
		-e "s^@WIN32DLLDIR@^$${DLLDIR}^" < Makefile.inc.in > $@
	@grep EXTRA ../../autoconf/Make.common >> $@
	@grep DMSG ../../autoconf/Make.common >> $@

# Used to build windows dependency in a docker container for example
depkgs-win.tar.gz: External-mingw-w64 External-mingw32 build-depkgs-mingw32 build-depkgs-mingw-w64
	git archive --format tar.gz --prefix git/bacula/src/win32/ HEAD patches build-depkgs-mingw* External-mingw* > depkgs-win.tar.gz

=== src/plugins/dir/Makefile ===
#
# Simple Makefile for building test FD plugins for Bacula
#
# Copyright (C) 2000-2023 Kern Sibbald
# License: BSD 2-Clause; see file LICENSE-FOSS
#

include Makefile.inc

.c.lo:
	@echo "Compiling $< ..."
	$(NO_ECHO)$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(CFLAGS) -I${SRCDIR} -I${DIRDIR} -I${LIBDIR} -DWORKDIR=\"$(DESTDIR)$(working_dir)\" -c $<

%.lo: %.c %.h
	@echo "Pattern compiling $< ..."
	$(NO_ECHO)$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(CFLAGS) -I${SRCDIR} -I${DIRDIR} -I${LIBDIR} -DWORKDIR=\"$(DESTDIR)$(working_dir)\" -c $(@:.lo=.c)

all: dirpluglib.lo example-plugin-dir.la test-authentication-api-dir.la

install-totp:
	$(MAKE) -C totp/ install

# example-plugin-dir.lo: example-plugin-dir.c ${DIRDIR}/dir_plugins.h
# 	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CFLAGS) -I../.. -I${DIRDIR} -c example-plugin-dir.c

example-plugin-dir.la: example-plugin-dir.lo
	@echo "Linking $(@:.la=.so) ..."
	$(NO_ECHO)$(LIBTOOL_LINK) $(CXX) $(LDFLAGS) -shared example-plugin-dir.lo -o $@ -rpath $(plugindir) -module -export-dynamic -avoid-version

# test-authentication-api-dir.lo: test-authentication-api-dir.c ${DIRDIR}/dir_plugins.h
# 	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CFLAGS) -I../.. -I${DIRDIR} -c test-authentication-api-dir.c

test-authentication-api-dir.la: test-authentication-api-dir.lo dirpluglib.lo
	@echo "Linking $(@:.la=.so) ..."
	$(NO_ECHO)$(LIBTOOL_LINK) --silent $(CXX) $(LDFLAGS) -shared $^ -o $@ -rpath $(plugindir) -module -export-dynamic -avoid-version

install: all $(DIRPLUG_INSTALL_TARGET)
	$(NO_ECHO)$(MKDIR) $(DESTDIR)$(plugindir)

install-bpam-ldap:
	$(MAKE) -C ldap install

$(LIBTOOL_CLEAN_TARGET):
	$(NO_ECHO)find . -name '*.lo' -print | xargs $(LIBTOOL_CLEAN) $(RMF)
	$(NO_ECHO)$(RMF) *.la
	$(NO_ECHO)$(RMF) -r .libs _libs

clean: $(LIBTOOL_CLEAN_TARGET)
	$(NO_ECHO)rm -f main *.so *.o 1 2 3
	$(MAKE) -C totp clean
	$(MAKE) -C ldap clean

distclean: clean
	$(NO_ECHO)rm -f Makefile

$(LIBTOOL_UNINSTALL_TARGET):
	$(NO_ECHO)$(LIBTOOL_UNINSTALL) $(RMF) $(DESTDIR)$(plugindir)/example-plugin-dir.la

uninstall: $(LIBTOOL_UNINSTALL_TARGET)

depend:

=== src/plugins/fd/Makefile ===
#
# Simple Makefile for building test FD plugins for Bacula
#
# Copyright (C) 2000-2023 Kern Sibbald
# License: BSD 2-Clause; see file LICENSE-FOSS
#
#

include Makefile.inc


# No optimization for now for easy debugging

KUBESRC = kubernetes-fd.c kubernetes-fd.h
TESTKUBESRC = test_kubernetes_backend.c
KUBEOBJ = $(KUBESRC:.c=.lo) $(METAPLUGINOBJ)
TESTKUBEOBJ = $(TESTKUBESRC:.c=.lo)

.SUFFIXES:    .c .lo

.c.lo:
	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) -I${SRCDIR} -I${FDDIR} -I${LIBDIR} -I. -c $<

all: bpipe-fd.la

test-plugins: test-plugin-fd.la test-deltaseq-fd.la test-handlexacl-plugin-fd.la

test_kubernetes_backend.lo: $(TESTKUBESRC)
	@echo "Compiling $< ..."
	$(NO_ECHO)$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(CFLAGS) -I${SRCDIR} -I${FDDIR} -DLOGDIR=\"$(DESTDIR)$(working_dir)\" -c $<

kubernetes-fd.la: Makefile $(KUBEOBJ)
	@echo "Linking $(@:.la=.so) ..."
	$(NO_ECHO)$(LIBTOOL_LINK) --silent $(CXX) $(LDFLAGS) -shared $(KUBEOBJ) -o $@ -rpath $(plugindir) -module -export-dynamic -avoid-version

install-kubernetes: kubernetes-fd.la
	$(MAKE) -C kubernetes-backend install-kubernetes
	$(MKDIR) $(DESTDIR)$(plugindir)
	$(LIBTOOL_INSTALL) $(INSTALL_PROGRAM) kubernetes-fd.la $(DESTDIR)$(plugindir)
	$(NO_ECHO)$(RMF) $(DESTDIR)$(plugindir)/kubernetes-fd.la

install-test-kubernetes: test_kubernetes_backend kubernetes-fd.la
	$(MKDIR) $(DESTDIR)$(plugindir)
	$(LIBTOOL_INSTALL) $(INSTALL_PROGRAM) kubernetes-fd.la $(DESTDIR)$(plugindir)
	$(NO_ECHO)$(RMF) $(DESTDIR)$(plugindir)/kubernetes-fd.la
	$(LIBTOOL_INSTALL) $(INSTALL_PROGRAM) test_kubernetes_backend $(DESTDIR)$(sbindir)/k8s_backend

cdp: cdp-fd.la

cdp-fd.lo: cdp-fd.c journal.h folder-record.h file-record.h settings-record.h ${FDDIR}/fd_plugins.h
	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(CFLAGS) -Wno-unused-function -I../.. -I${FDDIR} -c cdp-fd.c

journal.lo: journal.c journal.h folder-record.h file-record.h settings-record.h ${FDDIR}/fd_plugins.h
	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(CFLAGS) -Wno-unused-function -I../.. -I${FDDIR} -c journal.c

cdp-fd.la: Makefile cdp-fd$(DEFAULT_OBJECT_TYPE) journal.lo
	$(LIBTOOL_LINK) $(CXX) $(LDFLAGS) -shared cdp-fd.lo journal.lo -o $@ -rpath $(plugindir) -module -export-dynamic -avoid-version

install-cdp: cdp-fd.la
	$(LIBTOOL_INSTALL) $(INSTALL_PROGRAM) cdp-fd.la $(DESTDIR)$(plugindir)
	$(RMF) $(DESTDIR)$(plugindir)/cdp-fd.la

rot13: rot13-fd.la

all: bpipe-fd.la test-plugin-fd.la test-deltaseq-fd.la

example-plugin-fd.lo: example-plugin-fd.c ${FDDIR}/fd_plugins.h
	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(CFLAGS) -I../.. -I${FDDIR} -c example-plugin-fd.c

example-plugin-fd.la: Makefile example-plugin-fd$(DEFAULT_OBJECT_TYPE)
	$(LIBTOOL_LINK) $(CXX) $(LDFLAGS) -shared example-plugin-fd.lo -o $@ -rpath $(plugindir) -module -export-dynamic -avoid-version

bpipe-fd.lo: bpipe-fd.c ${FDDIR}/fd_plugins.h
	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(CFLAGS) -I../.. -I${FDDIR} -c bpipe-fd.c

bpipe-fd.la: Makefile bpipe-fd$(DEFAULT_OBJECT_TYPE)
	$(LIBTOOL_LINK) $(CXX) $(LDFLAGS) -shared bpipe-fd.lo -o $@ -rpath $(plugindir) -module -export-dynamic -avoid-version

test-bpipe-fd.c: bpipe-fd.c
	cp -f bpipe-fd.c test-bpipe-fd.c

test-bpipe-fd.lo: test-bpipe-fd.c ${FDDIR}/fd_plugins.h
	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(CFLAGS) -DTEST_BPIPE_OFFSET -I../.. -I${FDDIR} -c test-bpipe-fd.c

test-bpipe-fd.la: Makefile test-bpipe-fd$(DEFAULT_OBJECT_TYPE)
	$(LIBTOOL_LINK) $(CXX) $(LDFLAGS) -shared test-bpipe-fd.lo -o $@ -rpath $(plugindir) -module -export-dynamic -avoid-version 

rot13-fd.lo: rot13-fd.c ${FDDIR}/fd_plugins.h
	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(CFLAGS) -I../.. -I${FDDIR} -c rot13-fd.c

rot13-fd.la: Makefile rot13-fd$(DEFAULT_OBJECT_TYPE)
	$(LIBTOOL_LINK) $(CXX) $(LDFLAGS) -shared rot13-fd.lo -o $@ -rpath $(plugindir) -module -export-dynamic -avoid-version 

namedpipe.lo: namedpipe.c namedpipe.h
	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(CFLAGS) -c namedpipe.c

test-deltaseq-fd.lo: test-deltaseq-fd.c ${FDDIR}/fd_plugins.h fd_common.h
	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(CFLAGS) -I../.. -I${FDDIR} -c test-deltaseq-fd.c

test-deltaseq-fd.la: Makefile test-deltaseq-fd$(DEFAULT_OBJECT_TYPE)
	$(LIBTOOL_LINK) $(CXX) $(LDFLAGS) -shared test-deltaseq-fd.lo -o $@ -rpath $(plugindir) -module -export-dynamic -avoid-version

delta-fd.lo: delta-fd.c ${FDDIR}/fd_plugins.h fd_common.h
	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(RSYNC_INC) $(CFLAGS) -I../.. -I${FDDIR} -c delta-fd.c

delta-fd.la: Makefile delta-fd$(DEFAULT_OBJECT_TYPE)
	$(LIBTOOL_LINK) $(CXX) $(LDFLAGS) $(RSYNC_LIBS) -shared delta-fd.lo -o $@ -rpath $(plugindir) -module -export-dynamic -avoid-version 

test-verify-fd.lo: test-verify-fd.c ${FDDIR}/fd_plugins.h fd_common.h
	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(RSYNC_INC) $(CFLAGS) -I../.. -I${FDDIR} -c test-verify-fd.c

test-verify-fd.la: Makefile test-verify-fd$(DEFAULT_OBJECT_TYPE)
	$(LIBTOOL_LINK) $(CXX) $(LDFLAGS) -shared test-verify-fd.lo -o $@ -rpath $(plugindir) -module -export-dynamic -avoid-version

install-antivirus: antivirus-fd.la
	$(MKDIR) $(DESTDIR)$(plugindir)
	$(LIBTOOL_INSTALL) $(INSTALL_PROGRAM) antivirus-fd.la $(DESTDIR)$(plugindir)
	$(RMF) $(DESTDIR)$(plugindir)/antivirus-fd.la

antivirus-fd.lo: antivirus-fd.c ${FDDIR}/fd_plugins.h fd_common.h
	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(CFLAGS) -I../.. -I${FDDIR} -c antivirus-fd.c

antivirus-fd.la: Makefile antivirus-fd$(DEFAULT_OBJECT_TYPE)
	$(LIBTOOL_LINK) $(CXX) $(LDFLAGS) -shared antivirus-fd.lo -o $@ -rpath $(plugindir) -module -export-dynamic -avoid-version

test-plugin-fd.lo: test-plugin-fd.c ${FDDIR}/fd_plugins.h
	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(CFLAGS) -I../.. -I${FDDIR} -c test-plugin-fd.c

test-plugin-fd.la: Makefile test-plugin-fd$(DEFAULT_OBJECT_TYPE)
	$(LIBTOOL_LINK) $(CXX) $(LDFLAGS) -shared test-plugin-fd.lo -o $@ -rpath $(plugindir) -module -export-dynamic -avoid-version

test-handlexacl-plugin-fd.lo: test-handlexacl-plugin-fd.c ${FDDIR}/fd_plugins.h
	$(LIBTOOL_COMPILE) $(CXX) $(DEFS) $(DEBUG) $(CPPFLAGS) $(CFLAGS) -I../.. -I${FDDIR} -c test-handlexacl-plugin-fd.c

test-handlexacl-plugin-fd.la: Makefile test-handlexacl-plugin-fd$(DEFAULT_OBJECT_TYPE)
	$(LIBTOOL_LINK) $(CXX) $(LDFLAGS) -shared test-handlexacl-plugin-fd.lo -o $@ -rpath $(plugindir) -module -export-dynamic -avoid-version 

test_kubernetes_backend: Makefile $(TESTKUBEOBJ) $(PLUGINLIBDIR)/test_metaplugin_backend.lo
	@echo "Building backend $@ ..."
	$(NO_ECHO)$(LIBTOOL_LINK) --silent $(CXX) $(LDFLAGS) test_kubernetes_backend.lo $(PLUGINLIBDIR)/test_metaplugin_backend.lo -o $@

install: all $(EXTRA_INSTALL_TARGET)
	$(MKDIR) $(DESTDIR)$(plugindir)
	$(LIBTOOL_INSTALL) $(INSTALL_PROGRAM) bpipe-fd.la $(DESTDIR)$(plugindir)
	$(RMF) $(DESTDIR)$(plugindir)/bpipe-fd.la

install-docker:
	$(MAKE) -C docker install-docker

install-test-plugin: all test-plugins test-bpipe-fd.la rot13-fd.la
	$(MKDIR) $(DESTDIR)$(plugindir)
	$(LIBTOOL_INSTALL) $(INSTALL_PROGRAM) test-plugin-fd.la $(DESTDIR)$(plugindir)
	$(RMF) $(DESTDIR)$(plugindir)/test-plugin-fd.la
	$(LIBTOOL_INSTALL) $(INSTALL_PROGRAM) test-deltaseq-fd.la $(DESTDIR)$(plugindir)
	$(RMF) $(DESTDIR)$(plugindir)/test-deltaseq-fd.la
	$(LIBTOOL_INSTALL) $(INSTALL_PROGRAM) test-handlexacl-plugin-fd.la $(DESTDIR)$(plugindir)
	$(RMF) $(DESTDIR)$(plugindir)/test-handlexacl-plugin-fd.la
	$(LIBTOOL_INSTALL) $(INSTALL_PROGRAM) test-bpipe-fd.la $(DESTDIR)$(plugindir)
	$(RMF) $(DESTDIR)$(plugindir)/test-bpipe-fd.la
	$(LIBTOOL_INSTALL) $(INSTALL_PROGRAM) rot13-fd.la $(DESTDIR)$(plugindir)
	$(RMF) $(DESTDIR)$(plugindir)/rot13-fd.la

install-test-dedup: test-dedup-fd.la
	$(MKDIR) $(DESTDIR)$(plugindir)
	$(LIBTOOL_INSTALL) $(INSTALL_PROGRAM) test-dedup-fd.la $(DESTDIR)$(plugindir)
	$(RMF) $(DESTDIR)$(plugindir)/test-dedup-fd.la

install-delta-plugin: all delta-fd.la
	$(LIBTOOL_INSTALL) $(INSTALL_PROGRAM) delta-fd.la $(DESTDIR)$(plugindir)
	$(RMF) $(DESTDIR)$(plugindir)/delta-fd.la

libtool-clean:
	@find . -name '*.lo' -print | xargs $(LIBTOOL_CLEAN) $(RMF)
	@$(RMF) *.la
	@$(RMF) -r .libs _libs

clean:	libtool-clean
	@rm -f main *.so *.o 1 2 3 *_test ndmp_idx_dump

distclean: clean
	@rm -f Makefile

libtool-uninstall:
	$(LIBTOOL_UNINSTALL) $(RMF) $(DESTDIR)$(plugindir)/bpipe-fd.so

uninstall: $(LIBTOOL_UNINSTALL_TARGET)

depend:

=== src/win32/console/Makefile ===
#
# Makefile for win32 bacula executables
# Using MinGW cross-compiler on GNU/Linux
#
# Author: Robert Nelson
# License: BSD 2-Clause; see file LICENSE-FOSS
#
#  Written by Robert Nelson, June 2006
#

include ../Makefile.inc

INCLUDES = \
	$(INCLUDE_BACULA) \
	$(INCLUDE_PTHREADS) \
	$(INCLUDE_OPENSSL)

DEFINES = \
	-DUSING_DLL \
	$(HAVES)

vpath %.c $(MAINDIR)/src/console
vpath %.cpp $(MAINDIR)/src/console

##########################################################################

CONSOLE_OBJS = \
	$(OBJDIR)/authenticate.o \
	$(OBJDIR)/console.o \
	$(OBJDIR)/console_conf.o

ALL_OBJS = $(CONSOLE_OBJS)

CONSOLE_LIBS = $(LIBS_NETWORK) 

######################################################################

# Targets

.PHONY: all clean distclean

all: $(BINDIR)/bconsole.exe

distclean: clean

clean:
	@echo "Cleaning `pwd`"
	$(call clean_obj,$(ALL_OBJS))
	$(call clean_exe,$(BINDIR)/bconsole.exe)
	$(ECHO_CMD)rm -rf $(OBJDIRS)

#
# Rules
#

$(BINDIR)/bconsole.exe: $(CONSOLE_OBJS) $(LIBS_BACULA)
	$(call link_conapp,$(CONSOLE_LIBS))

include ../Makefile.rules

=== src/win32/filed/Makefile ===
#
# Makefile for win32 bacula executables
# Using MinGW cross-compiler on GNU/Linux
#
#
# Author: Robert Nelson
# License: BSD 2-Clause; see file LICENSE-FOSS
#
#  Written by Robert Nelson, June 2006
#

#
# Change the following depending on where this directory is located
#  in the Bacula tree.	It should point to the src/win32 directory.
BUILDDIR = ..

include $(BUILDDIR)/Makefile.inc

INCLUDES = \
	-I. \
	$(INCLUDE_PTHREADS) \
	$(INCLUDE_BACULA) \
	$(INCLUDE_ZLIB) \
	$(INCLUDE_VSS) \
	$(INCLUDE_OPENSSL) \
	$(INCLUDE_ICONS)

DEFINES = \
	-DUSING_DLL \
	-DWIN32_VSS \
	-DWINVER=0x500 \
	$(HAVES)

#	-DHAVE_TRAY_MONITOR \


vpath %.c $(MAINDIR)/src/filed $(BUILDDIR)/libwin32
vpath %.cpp $(MAINDIR)/src/filed $(BUILDDIR)/libwin32

##########################################################################

EXTRA_FILED_OBJS_ORG = $(EXTRA_FILED_SRCS:.c=.o)

EXTRA_FILED_OBJS = $(addprefix $(OBJDIR)/, $(EXTRA_FILED_OBJS_ORG))

FILED_OBJS = \
	$(OBJDIR)/accurate.o \
	$(OBJDIR)/authenticate.o \
	$(OBJDIR)/backup.o \
	$(OBJDIR)/crypto.o \
	$(OBJDIR)/fdcollect.o \
	$(OBJDIR)/win_efs.o \
	$(OBJDIR)/estimate.o \
	$(OBJDIR)/fd_plugins.o \
	$(OBJDIR)/fd_snapshot.o \
	$(OBJDIR)/filed.o \
	$(OBJDIR)/filed_conf.o \
	$(OBJDIR)/heartbeat.o \
	$(OBJDIR)/hello.o \
	$(OBJDIR)/job.o \
	$(OBJDIR)/restore.o \
	$(OBJDIR)/status.o \
	$(OBJDIR)/verify.o \
	$(OBJDIR)/verify_vol.o \
	$(OBJDIR)/vss.o \
	$(OBJDIR)/vss_XP.o \
	$(OBJDIR)/vss_W2K3.o \
	$(OBJDIR)/vss_Vista.o \
	$(OBJDIR)/service.o \
	$(OBJDIR)/main.o \
	$(OBJDIR)/bacl.o \
	$(OBJDIR)/bacl_linux.o \
	$(OBJDIR)/bacl_solaris.o \
	$(OBJDIR)/bxattr_freebsd.o \
	$(OBJDIR)/bxattr_osx.o \
	$(OBJDIR)/bacl_freebsd.o \
	$(OBJDIR)/bacl_osx.o \
	$(OBJDIR)/bxattr.o \
	$(OBJDIR)/bxattr_linux.o \
	$(OBJDIR)/bxattr_solaris.o \
	$(OBJDIR)/fdcallsdir.o \
	$(OBJDIR)/runres_conf.o \
	$(OBJDIR)/suspend.o \
	$(OBJDIR)/bacgpfs.o \
	$(EXTRA_FILED_OBJS) \
	$(OBJDIR)/bacula.res

#	$(OBJDIR)/trayMonitor.o \
#	$(OBJDIR)/aboutDialog.o \
#	$(OBJDIR)/statusDialog.o \


ALL_OBJS = $(FILED_OBJS)

FILED_LIBS = \
	$(LIBS_PTHREADS) \
	$(LIBS_ZLIB) \
	$(LIBS_LZO) \
	$(LIBS_ZSTD) \
	$(LIBS_NETWORK) \
	-lole32 \
	-loleaut32 \
	-luuid \
	-lcomctl32

######################################################################

# Targets

.PHONY: all clean distclean

all: $(BINDIR)/bacula-fd.exe

distclean: clean

clean:
	@echo "Cleaning `pwd`"
	$(call clean_obj,$(ALL_OBJS))
	$(call clean_exe,$(BINDIR)/bacula-fd.exe)
	$(ECHO_CMD)rm -rf $(OBJDIRS)

#
# Rules
#

$(BINDIR)/bacula-fd.exe: $(FILED_OBJS) $(LIBS_BACULA)
	$(call link_winapp,$(FILED_LIBS))

include $(BUILDDIR)/Makefile.rules

=== src/win32/lib/Makefile ===
#
# Makefile for win32 bacula executables
# Using MinGW cross-compiler on GNU/Linux
#
#  Written by Robert Nelson, June 2006
#

include ../Makefile.inc

INCLUDES = \
	$(INCLUDE_PTHREADS) \
	$(INCLUDE_BACULA) \
	$(INCLUDE_ZLIB) \
	$(INCLUDE_OPENSSL)

DEFINES = \
	$(HAVES)

vpath %.c $(BUILDDIR)/compat $(MAINDIR)/src/findlib $(MAINDIR)/src/lib
vpath %.cpp $(BUILDDIR)/compat $(MAINDIR)/src/findlib $(MAINDIR)/src/lib
vpath %.cc $(BUILDDIR)/compat $(MAINDIR)/src/findlib $(MAINDIR)/src/lib

######################################################################

EXTRA_FINDLIB_OBJS_ORG = $(EXTRA_FINDLIB_SRCS:.c=.o)
EXTRA_FINDLIB_OBJS = $(addprefix $(OBJDIR)/, $(EXTRA_FINDLIB_OBJS_ORG))

EXTRA_LIB_OBJS_ORG = $(EXTRA_LIB_SRCS:.c=.o)
EXTRA_LIB_OBJS = $(addprefix $(OBJDIR)/, $(EXTRA_LIB_OBJS_ORG))

# Files files in src/lib

COMPAT_OBJS = \
	$(OBJDIR)/compat.o \
	$(OBJDIR)/print.o \
	$(OBJDIR)/winapi.o \
	$(OBJDIR)/mtab.o

FIND_OBJS = \
	$(OBJDIR)/attribs.o \
	$(OBJDIR)/bfile.o \
	$(OBJDIR)/win32filter.o \
	$(OBJDIR)/create_file.o \
	$(OBJDIR)/drivetype.o \
	$(OBJDIR)/enable_priv.o \
	$(OBJDIR)/find.o \
	$(OBJDIR)/find_one.o \
	$(OBJDIR)/fstype.o \
	$(OBJDIR)/mkpath.o \
	$(OBJDIR)/match.o \
	$(EXTRA_FINDLIB_OBJS)

LIB_OBJS = \
	$(OBJDIR)/address_conf.o \
	$(OBJDIR)/alist.o \
	$(OBJDIR)/ilist.o \
	$(OBJDIR)/attr.o \
	$(OBJDIR)/base64.o \
	$(OBJDIR)/berrno.o \
	$(OBJDIR)/bget_msg.o \
	$(OBJDIR)/bnet.o \
	$(OBJDIR)/bnet_server.o \
	$(OBJDIR)/bpipe.o \
	$(OBJDIR)/breg.o \
	$(OBJDIR)/bregex.o \
	$(OBJDIR)/bsock.o \
	$(OBJDIR)/bsockcore.o \
	$(OBJDIR)/bstat.o \
	$(OBJDIR)/bcollector.o \
	$(OBJDIR)/collect.o \
	$(OBJDIR)/bsnprintf.o \
	$(OBJDIR)/bsys.o \
	$(OBJDIR)/btime.o \
	$(OBJDIR)/btimers.o \
	$(OBJDIR)/cram-md5.o \
	$(OBJDIR)/crypto.o \
	$(OBJDIR)/daemon.o \
	$(OBJDIR)/dlist.o \
	$(OBJDIR)/edit.o \
	$(OBJDIR)/fnmatch.o \
	$(OBJDIR)/guid_to_name.o \
	$(OBJDIR)/hmac.o \
	$(OBJDIR)/htable.o \
	$(OBJDIR)/jcr.o \
	$(OBJDIR)/lex.o \
	$(OBJDIR)/lz4.o \
	$(OBJDIR)/md5.o \
	$(OBJDIR)/mem_pool.o \
	$(OBJDIR)/message.o \
	$(OBJDIR)/openssl.o \
	$(OBJDIR)/plugins.o \
	$(OBJDIR)/priv.o \
	$(OBJDIR)/queue.o \
	$(OBJDIR)/rblist.o \
	$(OBJDIR)/runscript.o \
	$(OBJDIR)/rwlock.o \
	$(OBJDIR)/scan.o \
	$(OBJDIR)/serial.o \
	$(OBJDIR)/sha1.o \
	$(OBJDIR)/signal.o \
	$(OBJDIR)/smartall.o \
	$(OBJDIR)/tls.o \
	$(OBJDIR)/tree.o \
	$(OBJDIR)/util.o \
	$(OBJDIR)/var.o \
	$(OBJDIR)/watchdog.o \
	$(OBJDIR)/workq.o \
	$(OBJDIR)/binflate.o \
	$(OBJDIR)/ini.o \
	$(OBJDIR)/output.o \
	$(OBJDIR)/sellist.o \
	$(OBJDIR)/lockmgr.o \
	$(OBJDIR)/worker.o \
	$(OBJDIR)/bsock_meeting.o \
	$(OBJDIR)/authenticatebase.o \
	$(OBJDIR)/flist.o \
	$(OBJDIR)/bcrc32.o \
	$(OBJDIR)/events.o \
	$(OBJDIR)/cJSON.o \
	$(OBJDIR)/cJSON_Utils.o \
	$(OBJDIR)/xxhash.o \
	$(OBJDIR)/xxh_x86dispatch.o \
	$(EXTRA_LIB_OBJS)

DLL_OBJS = \
	$(COMPAT_OBJS) $(FIND_OBJS) $(LIB_OBJS)

STATIC_OBJS = \
	$(OBJDIR)/parse_conf.o \
	$(OBJDIR)/res.o

ALL_OBJS = \
	$(DLL_OBJS) $(STATIC_OBJS)

LIBS_DLL = \
	$(LIBS_SSL) \
	$(LIBS_CRYPTO) \
	$(LIBS_PTHREADS) \
	$(LIBS_ZLIB) \
	$(LIBS_NETWORK) \
	-lole32 \
	-loleaut32 \
	-lws2_32 \
	-luuid

######################################################################

# Targets

.PHONY: all clean distclean

all: $(BINDIR)/bacula.dll $(LIBDIR)/libbacula.a

distclean: clean

clean:
	@echo "Cleaning `pwd`"
	$(call clean_obj,$(ALL_OBJS))
	$(call clean_exe,$(BINDIR)/bacula.dll)
	$(ECHO_CMD)rm -f $(OBJDIR)/bacula.a $(LIBDIR)/libbacula.a
	$(ECHO_CMD)rm -rf $(OBJDIRS)

tests: $(BINDIR)/bsock_meeting_test

#
# Rules for generating from ../lib
#

$(LIBDIR)/libbacula.a: DLL_DEFINE=USING_DLL

$(LIBDIR)/libbacula.a: $(BINDIR)/bacula.dll $(STATIC_OBJS)
	@echo "Updating archive $@"
	$(call checkdir,$@)
	$(ECHO_CMD)cp $(OBJDIR)/bacula.a $@
	$(ECHO_CMD)$(AR) rsv $@ $(filter %.o,$^)

$(BINDIR)/bacula.dll: DLL_DEFINE=BUILDING_DLL

$(BINDIR)/bacula.dll: $(DLL_OBJS) bacula$(WIN_VERSION).def
	@echo "Linking $@"
	$(call checkdir,$@)
	$(ECHO_CMD)$(CXX) $(LDFLAGS) -mdll -mwindows -Wl,--out-implib,$(OBJDIR)/bacula.a $^ $(LIBS_DLL) -o $@
	$(BUILDDIR)/sign-binaries $@

bacula$(WIN_VERSION).def: $(DLL_OBJS)
	./make_def$(WIN_VERSION) $(DLL_OBJS) >bacula$(WIN_VERSION).def.new && \
	  mv bacula$(WIN_VERSION).def.new bacula$(WIN_VERSION).def


include ../Makefile.rules

$(OBJDIR)/%.o: %.c
	@echo "Compiling $<"
	$(call checkdir,$@)
	$(ECHO_CMD)$(CXX) -D$(DLL_DEFINE) $(CFLAGS) -c $< -o $@

# use -fno-asynchronous-unwind-tables to compile xxh_x86dispatch.c as "suggested" 
# https://review.spdk.io/gerrit/plugins/gitiles/spdk/rocksdb/+/eeb3cf3f58385eac17654fcfeaf288e568673db8/CMakeLists.txt
# https://github.com/pymc-devs/pymc/issues/4749
# maybe there is something better to do
$(OBJDIR)/xxh_x86dispatch.o: xxh_x86dispatch.c
	@echo "Compiling $<"
	$(call checkdir,$@)
	$(ECHO_CMD)$(CXX) -fno-asynchronous-unwind-tables -D$(DLL_DEFINE) $(CFLAGS) -c $< -o $@

$(OBJDIR)/%.o: %.cpp
	@echo "Compiling $<"
	$(call checkdir,$@)
	$(ECHO_CMD)$(CXX) -D$(DLL_DEFINE) $(CFLAGS) -c $< -o $@

$(OBJDIR)/%.o: %.cc
	@echo "Compiling $<"
	$(call checkdir,$@)
	$(ECHO_CMD)$(CXX) -D$(DLL_DEFINE) $(CFLAGS) -c $< -o $@

=== src/win32/libbac/Makefile ===
#
# Copyright (C) 2000-2023 Kern Sibbald
# License: BSD 2-Clause; see file LICENSE-FOSS
#
# Makefile for win32 bacula executables
# Using MinGW cross-compiler on GNU/Linux
#  
#  Written for Bacula by Howard Thomson, April 2006
#    for building using cross-complilation.
# 

include ../Makefile.inc

INCLUDES = \
	$(INCLUDE_GCC) \
	$(INCLUDE_MINGW) \
	$(INCLUDE_PTHREADS) \
	$(INCLUDE_BACULA) \
	$(INCLUDE_ZLIB) \
	$(INCLUDE_VSS) \
	$(INCLUDE_ICONS) \
	$(INCLUDE_OPENSSL)

DEFINES = \
	-DWIN32 \
	$(HAVES)

######################################################################

# Files files in src/lib

LIB_OBJS = \
	$(OBJDIR)/address_conf.o \
	$(OBJDIR)/alist.o \
	$(OBJDIR)/attr.o \
	$(OBJDIR)/base64.o \
	$(OBJDIR)/berrno.o \
	$(OBJDIR)/bget_msg.o \
	$(OBJDIR)/bnet.o \
	$(OBJDIR)/bnet_server.o \
	$(OBJDIR)/bpipe.o \
	$(OBJDIR)/bregex.o \
	$(OBJDIR)/bshm.o \
	$(OBJDIR)/bsnprintf.o \
	$(OBJDIR)/bsock.o \
	$(OBJDIR)/bsys.o \
	$(OBJDIR)/btime.o \
	$(OBJDIR)/btimers.o \
	$(OBJDIR)/cram-md5.o \
	$(OBJDIR)/crc32.o \
	$(OBJDIR)/crypto.o \
	$(OBJDIR)/daemon.o \
	$(OBJDIR)/dlist.o \
	$(OBJDIR)/edit.o \
	$(OBJDIR)/enh_fnmatch.o \
	$(OBJDIR)/fnmatch.o \
	$(OBJDIR)/hmac.o \
	$(OBJDIR)/htable.o \
	$(OBJDIR)/idcache.o \
	$(OBJDIR)/jcr.o \
	$(OBJDIR)/lex.o \
	$(OBJDIR)/md5.o \
	$(OBJDIR)/mem_pool.o \
	$(OBJDIR)/message.o \
	$(OBJDIR)/openssl.o \
	$(OBJDIR)/parse_conf.o \
	$(OBJDIR)/pythonlib.o \
	$(OBJDIR)/queue.o \
	$(OBJDIR)/rblist.o \
	$(OBJDIR)/res.o \
	$(OBJDIR)/runscript.o \
	$(OBJDIR)/rwlock.o \
	$(OBJDIR)/scan.o \
	$(OBJDIR)/serial.o \
	$(OBJDIR)/sha1.o \
	$(OBJDIR)/signal.o \
	$(OBJDIR)/smartall.o \
	$(OBJDIR)/tls.o \
	$(OBJDIR)/tree.o \
	$(OBJDIR)/util.o \
	$(OBJDIR)/var.o \
	$(OBJDIR)/watchdog.o \
	$(OBJDIR)/winapi.o \
	$(OBJDIR)/workq.o \
	$(OBJDIR)/lockmgr.o

#	$(LIBDIR)/events.o

######################################################################

# Targets

.PHONY: all clean

all: $(LIBDIR)/libbac.a

clean:
	@echo "Cleaning `pwd`"
	$(ECHO_CMD)rm -f $(OBJDIR)/*.[od] $(LIBDIR)/libbac.a

#
# Rules
# 

$(LIBDIR)/libbac.a: $(LIB_OBJS)
	@echo "Updating archive $@"
	$(call checkdir,$@)
	$(ECHO_CMD)$(AR) rs $@ $^

include ../Makefile.rules

ifneq ($(MAKECMDGOALS),clean)
include $(patsubst %.o,%.d,$(filter-out %.res,$(LIB_OBJS)))
endif

=== src/win32/stored/Makefile ===
#
# Makefile for win32 bacula executables
# Using MinGW cross-compiler on GNU/Linux
#
#
# Author: Robert Nelson
# License: BSD 2-Clause; see file LICENSE-FOSS
#
#  Written by Robert Nelson, June 2006
#

# Configuration

include ../Makefile.inc

INCLUDES = \
	-I. \
	-I$(MAINDIR)/src/stored \
	$(INCLUDE_DDK) \
	$(INCLUDE_PTHREADS) \
	$(INCLUDE_BACULA) \
	$(INCLUDE_ZLIB) \
	$(INCLUDE_OPENSSL) \
	$(INCLUDE_ICONS)

DEFINES = \
	-DUSING_DLL \
	-DWINVER=0x500 \
	$(HAVES)

#	-DHAVE_TRAY_MONITOR \

EXTRA_LIBSD_OBJS_ORG = $(EXTRA_LIBSD_SRCS:.c=.o) $(EXTRA_LIBSD_SRCS:.c=.o)
EXTRA_LIBSD_OBJS = $(addprefix $(OBJDIR)/, $(EXTRA_LIBSD_OBJS_ORG))

EXTRA_STORED_OBJS_ORG = $(EXTRA_STORED_SRCS:.c=.o) $(EXTRA_LIBSD_SRCS:.c=.o)
EXTRA_STORED_OBJS = $(addprefix $(OBJDIR)/, $(EXTRA_STORED_OBJS_ORG))

EXTRA_BLS_OBJS_ORG = $(EXTRA_BLS_SRCS:.c=.o)
EXTRA_BLS_OBJS = $(addprefix $(OBJDIR)/, $(EXTRA_BLS_OBJS_ORG))

vpath %.c $(MAINDIR)/src/stored $(BUILDDIR)/libwin32
vpath %.cpp $(MAINDIR)/src/stored $(BUILDDIR)/libwin32

##########################################################################

COMMON_OBJS = \
	$(OBJDIR)/askdir.o \
	$(OBJDIR)/tape_alert.o \
	$(OBJDIR)/vtape_dev.o \
	$(OBJDIR)/tape_worm.o \
	$(OBJDIR)/tape_dev.o \
	$(OBJDIR)/init_dev.o \
	$(OBJDIR)/global.o \
	$(OBJDIR)/acquire.o \
	$(OBJDIR)/aligned_dev.o \
	$(OBJDIR)/aligned_read.o \
	$(OBJDIR)/aligned_write.o \
	$(OBJDIR)/ansi_label.o \
	$(OBJDIR)/authenticate.o \
	$(OBJDIR)/autochanger.o \
	$(OBJDIR)/block.o \
	$(OBJDIR)/block_util.o \
	$(OBJDIR)/butil.o \
	$(OBJDIR)/dev.o \
	$(OBJDIR)/device.o \
	$(OBJDIR)/ebcdic.o \
	$(OBJDIR)/hello.o \
	$(OBJDIR)/label.o \
	$(OBJDIR)/lock.o \
	$(OBJDIR)/match_bsr.o \
	$(OBJDIR)/mount.o \
	$(OBJDIR)/parse_bsr.o \
	$(OBJDIR)/read_records.o \
	$(OBJDIR)/record_read.o \
	$(OBJDIR)/record_util.o \
	$(OBJDIR)/record_write.o \
	$(OBJDIR)/reserve.o \
	$(OBJDIR)/scan.o \
	$(OBJDIR)/spool.o \
	$(OBJDIR)/stored_conf.o \
	$(OBJDIR)/vol_mgr.o \
	$(OBJDIR)/wait.o \
	$(OBJDIR)/file_dev.o \
	$(OBJDIR)/sd_plugins.o \
	$(OBJDIR)/os.o \
	$(EXTRA_LIBSD_OBJS)


#	 $(OBJDIR)/mtops.o

# bacula-sd
SD_OBJS = \
	$(OBJDIR)/sdcollect.o \
	$(OBJDIR)/stored.o \
	$(OBJDIR)/append.o \
	$(OBJDIR)/dircmd.o \
	$(OBJDIR)/fd_cmds.o \
	$(OBJDIR)/job.o \
	$(OBJDIR)/read.o \
	$(OBJDIR)/vbackup.o \
	$(OBJDIR)/status.o \
	$(OBJDIR)/store_mngr.o \
	$(EXTRA_STORED_OBJS)

# bextract
BEXTRACT_OBJS = \
	$(OBJDIR)/bextract.o 

OBJS_WIN = \
	$(OBJDIR)/service.o \
	$(OBJDIR)/main.o \
	$(OBJDIR)/bacula.res

#	$(OBJDIR)/trayMonitor.o \
#	$(OBJDIR)/aboutDialog.o \
#	$(OBJDIR)/statusDialog.o \


ALL_OBJS = \
	$(COMMON_OBJS) \
	$(SD_OBJS) \
	$(BEXTRACT_OBJS) \
	$(OBJS_WIN) \
	$(OBJDIR)/bcopy.o \
	$(OBJDIR)/bls.o \
	$(OBJDIR)/btape.o \
	$(OBJDIR)/bscan.o

LIBS_STORED = \
	$(LIBS_PTHREADS) \
	$(LIBS_NETWORK) \
	-lole32 \
	-loleaut32 \
	-luuid \
	-lcomctl32

######################################################################

# Targets

.PHONY: all clean

all:	$(BINDIR)/bacula-sd.exe  $(BINDIR)/bcopy.exe $(BINDIR)/bextract.exe  $(BINDIR)/bls.exe 
# $(BINDIR)/bscan.exe $(BINDIR)/btape.exe

clean:
	@echo "Cleaning `pwd`"
	$(call clean_obj,$(ALL_OBJS))
	$(call clean_exe,$(BINDIR)/bacula-sd.exe)
	$(call clean_exe,$(BINDIR)/bcopy.exe)
	$(call clean_exe,$(BINDIR)/bextract.exe)
	$(call clean_exe,$(BINDIR)/bls.exe)
	$(call clean_exe,$(BINDIR)/bscan.exe)
	$(call clean_exe,$(BINDIR)/btape.exe)
	$(ECHO_CMD)rm -rf $(OBJDIRS)

realclean: clean
	rm -f tags bacula-sd.conf

#
# Rules
#

$(BINDIR)/bacula-sd.exe: $(SD_OBJS) $(COMMON_OBJS) $(OBJS_WIN) $(LIBS_BACULA)
	$(call link_winapp,$(LIBS_STORED))

$(BINDIR)/btape.exe: $(OBJDIR)/btape.o $(COMMON_OBJS) $(LIBS_BACULA)
	$(call link_conapp,$(LIBS_STORED))

$(BINDIR)/bls.exe: $(OBJDIR)/bls.o $(EXTRA_BLS_OBJS) $(COMMON_OBJS) $(LIBS_BACULA)
	$(call link_conapp,$(LIBS_STORED))

$(BINDIR)/bextract.exe: $(BEXTRACT_OBJS) $(COMMON_OBJS) $(LIBS_BACULA) $(LIBS_LZO) $(LIBS_ZSTD)
	$(call link_conapp,$(LIBS_STORED) $(LIBS_ZLIB))

$(BINDIR)/bscan.exe: $(OBJDIR)/bscan.o $(COMMON_OBJS) $(LIBS_CATS) $(LIBS_BACULA)
	$(call link_conapp,$(LIBS_STORED))

$(BINDIR)/bcopy.exe: $(OBJDIR)/bcopy.o $(COMMON_OBJS) $(LIBS_BACULA)
	$(call link_conapp,$(LIBS_STORED))

$(OBJDIR)/mtops.o: mtops.cpp
	@echo "Compiling $@"
	$(call checkdir,$@)
	$(ECHO_CMD)$(CXX) $(CFLAGS) $(INCLUDE_DDK) -I../../stored -c $< -o $@

include ../Makefile.rules

=== debian/changelog ===
bacula (15.0.3-5) unstable; urgency=high

  [ Carsten Leonhardt ]
  * Fix debian/upstream/metadata to point to the upstream gitlab instance

  [ Sven Hartge ]
  * Add lintian overrides for false positives in *_postgresql_tables
  * Fix Lintian warning about wrong field value for BTS URL in patch.
  * Expand templating mechanism for control files
  * Fix lintian overrides for bacula-director-pgsql
  * Revert "use UTF8 encoding for new postgresql databases"
    (LP: #2121318)

 -- Carsten Leonhardt <leo@debian.org>  Mon, 25 Aug 2025 10:13:59 +0200

bacula (15.0.3-4) unstable; urgency=medium

  [ Sven Hartge ]
  * Add support for ZSTD compression.
  * Pull 8d9669fb2 from Upstream git to fix libzstd detection
  * Flip debconf question about DB upgrade space to default to true
    (Closes: #1109499)

  [ Carsten Leonhardt ]
  * Rework handling of database upgrade scripts in regard to shell quoting
    (Closes: #1108272)
  * Show a message when the user decides to abort the upgrade (Closes: #1109565)

  [ Jonas Jelten ]
  * use UTF8 encoding for new postgresql databases

 -- Carsten Leonhardt <leo@debian.org>  Wed, 13 Aug 2025 10:10:27 +0200

bacula (15.0.3-3) unstable; urgency=medium

  [ Jean-Paul Guillonneau ]
  * Add French translation for bacula's debconf messages (Closes: #1102718)

  [ Amar ]
  * Add Arabic translation for bacula's debconf messages

  [ Nuri KÜÇÜKLER ]
  * Add Turkish translation for bacula's debconf messages

 -- Carsten Leonhardt <leo@debian.org>  Thu, 24 Apr 2025 17:00:09 +0200

bacula (15.0.3-2) unstable; urgency=medium

  [ Américo Monteiro ]
  * Updated Portuguese translation for bacula's debconf messages (Closes: #1101955)

  [ Pablo ]
  * Add Galician translation for bacula's debconf messages

  [ Camaleón ]
  * Add Spanish translation for bacula's debconf messages (Closes: #1102352)

  [ Luca Vercelli ]
  * Add Italian translation for bacula's debconf messages (Closes: #1102460)

 -- Carsten Leonhardt <leo@debian.org>  Wed, 09 Apr 2025 21:56:42 +0200

bacula (15.0.3-1) unstable; urgency=medium

  * New upstream version 15.0.3

  [ Sven Hartge ]
  * Refresh patches

 -- Carsten Leonhardt <leo@debian.org>  Sun, 30 Mar 2025 01:02:38 +0100

=== debian/control ===
Source: bacula
Section: admin
Priority: optional
Maintainer: Debian Bacula Team <pkg-bacula-devel@lists.alioth.debian.org>
Uploaders: Carsten Leonhardt <leo@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               autoconf,
               bc,
               default-libmysqlclient-dev,
               libacl1-dev,
               libcap-dev [linux-any],
               libkrb5-dev,
               liblzo2-dev,
               libpq-dev,
               libreadline-dev,
               libsqlite3-dev,
               libssl-dev,
               libwrap0-dev,
               libx11-dev,
               libxt-dev,
               libzstd-dev,
               mtx [!hurd-any],
               pkgconf,
               po-debconf,
               postgresql-server-dev-all,
               qtbase5-dev,
               systemd-dev [linux-any],
               zlib1g-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/bacula-team/bacula
Vcs-Git: https://salsa.debian.org/bacula-team/bacula.git
Homepage: https://www.bacula.org/

Package: bacula
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-client, bacula-server, ${misc:Depends}
Description: network backup service - metapackage
 Bacula is a set of programs to manage backup, recovery and verification
 of computer data across a network of computers of different kinds.
 .
 It is efficient and relatively easy to use, while offering many advanced
 storage management features that make it easy to find and recover lost or
 damaged files. Due to its modular design, Bacula is scalable from small
 single computer systems to networks of hundreds of machines.
 .
 This metapackage installs the entire suite of Bacula applications: job
 scheduling, storage control, node connector and administrative console.

Package: bacula-common
Architecture: any
Pre-Depends: adduser, debconf, ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: gdb
Description: network backup service - common support files
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides files that are useful for other Bacula packages.

Package: bacula-common-sqlite3
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common, ${misc:Depends}, ${shlibs:Depends}
Conflicts: bacula-common-mysql, bacula-common-pgsql
Description: network backup service - SQLite v3 common files
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides files that are useful for other Bacula packages
 for the SQLite v3 database.
 .
 Please be aware that using SQLite 3 databases is no longer supported
 by the author.

Package: bacula-common-pgsql
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common, ${misc:Depends}, ${shlibs:Depends}
Conflicts: bacula-common-mysql, bacula-common-sqlite3
Description: network backup service - PostgreSQL common files
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides files that are useful for other Bacula packages
 for the PostgreSQL database.

Package: bacula-common-mysql
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common, ${misc:Depends}, ${shlibs:Depends}
Conflicts: bacula-common-pgsql, bacula-common-sqlite3
Description: network backup service - MySQL common files
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides files that are useful for other Bacula packages
 for the MySQL database.

Package: bacula-director
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common (= ${binary:Version}),
         bacula-director-pgsql (= ${source:Version}) | bacula-director-mysql (= ${source:Version}) | bacula-director-sqlite3 (= ${source:Version}),
         bsd-mailx | mailx,
         sysvinit-utils (>= 3.05-1),
         ucf,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: python3
Suggests: bacula-doc, ${perl:Depends}
Replaces: bacula-common (<< 9.6.4-1)
Breaks: bacula-common (<< 9.6.4-1)
Description: network backup service - Director daemon
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The Bacula Director service supervises all the backup, restore, verify and
 archive operations. It can run as a daemon or as a foreground service which
 administrators can use to schedule backups and recover files.
 .
 This package provides the Bacula Director daemon.

Package: bacula-director-sqlite3
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common-sqlite3 (<< ${source:Version}.1~),
         bacula-common-sqlite3 (>= ${source:Version}),
         dbconfig-sqlite3 | dbconfig-no-thanks,
         file,
         sqlite3,
         ${misc:Depends}
Conflicts: bacula-director-database
Provides: bacula-director-database
Replaces: bacula-director-database
Suggests: gawk
Description: network backup service - SQLite 3 storage for Director
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The Bacula Director service supervises all the backup, restore, verify and
 archive operations. It can run as a daemon or as a foreground service which
 administrators can use to schedule backups and recover files.
 .
 This package stores Bacula's catalog in an SQLite 3 database and thus is
 only suitable for small or test installations.
 .
 Please be aware that using SQLite 3 databases is no longer supported
 by the author.

Package: bacula-director-mysql
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common-mysql (<< ${source:Version}.1~),
         bacula-common-mysql (>= ${source:Version}),
         dbconfig-mysql | dbconfig-no-thanks,
         default-mysql-client | virtual-mysql-client,
         ${misc:Depends}
Conflicts: bacula-director-database
Provides: bacula-director-database
Replaces: bacula-director-database
Recommends: default-mysql-server | virtual-mysql-server
Suggests: gawk
Description: network backup service - MySQL storage for Director
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The Bacula Director service supervises all the backup, restore, verify and
 archive operations. It can run as a daemon or as a foreground service which
 administrators can use to schedule backups and recover files.
 .
 This package stores Bacula's catalog in a MySQL database and thus is
 suitable for medium-sized installations.

Package: bacula-director-pgsql
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common-pgsql (<< ${source:Version}.1~),
         bacula-common-pgsql (>= ${source:Version}),
         dbconfig-pgsql | dbconfig-no-thanks,
         postgresql-client,
         ${misc:Depends}
Conflicts: bacula-director-database
Provides: bacula-director-database
Replaces: bacula-director-database
Recommends: postgresql
Suggests: gawk
Description: network backup service - PostgreSQL storage for Director
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The Bacula Director service supervises all the backup, restore, verify and
 archive operations. It can run as a daemon or as a foreground service which
 administrators can use to schedule backups and recover files.
 .
 This package stores Bacula's catalog in a PostgreSQL database and thus is
 suited for large installations.

Package: bacula-client
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-console (>= ${source:Version}),
         bacula-fd (>= ${source:Version}),
         ${misc:Depends}
Description: network backup service - client metapackage
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The Bacula Director service supervises all the backup, restore, verify and
 archive operations. It can run as a daemon or as a foreground service which
 administrators can use to schedule backups and recover files.
 .
 The package is a metapackage for client installations (file daemon and
 console only).

Package: bacula-fd
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common (= ${binary:Version}),
         sysvinit-utils (>= 3.05-1),
         ucf,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: bacula-common (<< 9.6.4-1)
Breaks: bacula-common (<< 9.6.4-1)
Description: network backup service - file daemon
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The file daemon has to be installed on the machine to be backed up. It is
 responsible for providing the file attributes and data when requested by
 the Director and also for the file system-dependent part of restoration.

Package: bacula-server
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-bscan (>= ${source:Version}),
         bacula-director (>= ${source:Version}),
         bacula-sd (>= ${source:Version}),
         ${misc:Depends}
Recommends: bacula-fd
Description: network backup service - server metapackage
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This metapackage provides a standard server install, consisting of the
 director and storage daemons.

Package: bacula-sd
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common (= ${binary:Version}),
         mtx [!hurd-any],
         sysvinit-utils (>= 3.05-1),
         ucf,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: bacula-common (<< 9.6.4-1),
          bacula-sd-mysql (<< 7.4.3+dfsg-3),
          bacula-sd-pgsql (<< 7.4.3+dfsg-3),
          bacula-sd-sqlite3 (<< 7.4.3+dfsg-3)
Breaks: bacula-common (<< 9.6.4-1),
        bacula-sd-mysql (<< 7.4.3+dfsg-3),
        bacula-sd-pgsql (<< 7.4.3+dfsg-3),
        bacula-sd-sqlite3 (<< 7.4.3+dfsg-3)
Recommends: bacula-bscan, mt-st, python3
Suggests: sg3-utils
Description: network backup service - storage daemon
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The storage daemon performs the storage and recovery of the file
 attributes and data to the physical media; in other words, it is
 responsible for reading and writing the backups.
 .
 It runs on the machine which has access to the backup device(s) - usually
 a tape drive, but alternatively other storage media, such as files.

Package: bacula-bscan
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: bacula-common-pgsql (= ${binary:Version}) | bacula-common-mysql (= ${binary:Version}) | bacula-common-sqlite3 (= ${binary:Version}),
         bacula-sd (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: bacula-sd-mysql (<< 7.4.3+dfsg-3),
          bacula-sd-pgsql (<< 7.4.3+dfsg-3),
          bacula-sd-sqlite3 (<< 7.4.3+dfsg-3)
Breaks: bacula-sd-mysql (<< 7.4.3+dfsg-3),
        bacula-sd-pgsql (<< 7.4.3+dfsg-3),
        bacula-sd-sqlite3 (<< 7.4.3+dfsg-3)
Description: network backup service - bscan tool
 Bacula is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The storage daemon performs the storage and recovery of the file
 attributes and data to the physical media; in other words, it is
 responsible for reading and writing the backups.
 .
 This package contains the bscan utility, which is used for recovery

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

# enable bindnow
# https://wiki.debian.org/HardeningWalkthrough
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Bacula binaries break if linked with symbolic-functions
# https://bugs.bacula.org/view.php?id=2557
# Debian does not (yet) use this, but Ubuntu does. Help them out by
# stripping the flag from LDFLAGS
# https://bugs.launchpad.net/ubuntu/+source/bacula/+bug/1898006
export DEB_LDFLAGS_MAINT_STRIP = -Wl,-Bsymbolic-functions

# Make qtchooser select Qt5
export QT_SELECT=qt5

DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

VARIANTS := pgsql mysql sqlite3
VERSION := $(shell sed -n -e 's/^\#define VERSION.*"\(.*\)"$$/\1/p' src/version.h)

######################################################################

DBC := usr/share/dbconfig-common/data/

CONF_ALL	= \
	--enable-smartalloc \
	--with-tcp-wrappers \
	--with-openssl \
	--with-libiconv-prefix=/usr/include \
	--with-readline=/usr/include/readline \
	--disable-conio \
	--with-libintl-prefix=/usr/include \
	--docdir=\$${prefix}/share/doc/bacula-common \
	--htmldir=\$${prefix}/share/doc/bacula-common/html \
	--libdir=\$${prefix}/lib/bacula \
	--enable-batch-insert \
	--enable-ipv6 \
	--with-dir-password=XXX_DIRPASSWORD_XXX \
	--with-fd-password=XXX_FDPASSWORD_XXX \
	--with-sd-password=XXX_SDPASSWORD_XXX \
	--with-mon-dir-password=XXX_MONDIRPASSWORD_XXX \
	--with-mon-fd-password=XXX_MONFDPASSWORD_XXX \
	--with-mon-sd-password=XXX_MONSDPASSWORD_XXX \
	--with-db-name=XXX_DBNAME_XXX \
	--with-db-user=XXX_DBUSER_XXX \
	--with-db-password=XXX_DBPASSWORD_XXX \
	--with-hostname=localhost \
	--config-cache \
	--with-archivedir=/nonexistent/path/to/file/archive/dir \
	--sysconfdir=/etc/bacula \
	--with-scriptdir=/etc/bacula/scripts \
	--sharedstatedir=/var/lib/bacula \
	--localstatedir=/var/lib/bacula \
	--with-logdir=/var/log/bacula \
	--with-pid-dir=/run/bacula \
	--with-smtp-host=localhost \
	--with-working-dir=/var/lib/bacula \
	--with-subsys-dir=/run/lock \
	--with-dump-email=root \
	--with-job-email=root \
	--with-mysql --with-postgresql --with-sqlite3 \
	--enable-bat --with-x \
	--disable-s3

ifeq ($(DEB_HOST_ARCH_OS),linux)
# Set systemd directories, needed to properly support usr-merge
SYSTEMDUNITDIR = $(shell pkg-config --variable=systemdsystemunitdir systemd | sed s,^/,,)
TMPFILESDIR = $(shell pkg-config --variable=tmpfilesdir systemd | sed s,^/,,)
CONF_ALL	+= --with-systemd=/$(SYSTEMDUNITDIR)
endif

ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
CONF_ALL	+= --disable-acl --disable-xattr
endif

ifeq ($(DEB_HOST_ARCH_OS),hurd)
CONF_ALL       += --disable-acl --disable-xattr
endif

#set to 1 if configured with systemd
HAVE_SYSTEMD = $(findstring 1,$(shell egrep "^\#define HAVE_SYSTEMD" config.log))

LONGNAME_mysql		= mysql
LONGNAME_pgsql		= postgresql
LONGNAME_sqlite3	= sqlite3

###########################################################################

# Macro for generate file for specified database from specified template
# args: 1 -- template file
#       2 -- db type
# Allows for DB-type specific .in files.
define template-subst
$(shell test -f '$(subst -db.,-$(2).,$(1))' && cp '$(subst -db.,-$(2).,$(1))' '$(patsubst %.in,%,$(subst -db.,-$(2).,$(1)))')
sed -e 's/XX_DB_XX/$(2)/' -e 's/XX_DBLONGNAME_XX/$(LONGNAME_$(2))/' -e 's/XX_VERSION_XX/$(VERSION)/' '$(1)' >> '$(patsubst %.in,%,$(subst -db.,-$(2).,$(1)))';
endef

# Macro for cleanup file generated for specified database from specified template
# args: 1 -- template file
#       2 -- db type
define template-cleanup
rm -f '$(patsubst %.in,%,$(subst -db.,-$(2).,$(1)))';
endef

# Macro for generate from all templates files for specified database
# args: 1 -- db type
define db-templates-subst
$(foreach template,$(wildcard debian/*-db.*.in),$(call template-subst,$(template),$(1)))
endef

# Macro for cleanup all files generated for specified database from templates
# args: 1 -- db type
define db-templates-cleanup
$(foreach template,$(wildcard debian/*-db.*.in),$(call template-cleanup,$(template),$(1)))
endef

%:
	dh $@

# For packages depending on bacula-director-DBTYPE, we handle the
# dependencies on that ourselves, because dpkg-shlibdeps doesn't
# understand the variants
override_dh_shlibdeps:
	dh_shlibdeps -pbacula-bscan -pbacula-director -- -xbacula-common-mysql -xbacula-common-pgsql -xbacula-common-sqlite3
	dh_shlibdeps -a --remaining-packages

override_dh_auto_build-arch:
	dh_auto_build -a
# also build the monitoring plugin from the examples
	make -C examples/nagios/check_bacula

override_dh_auto_install-arch:
	dh_auto_install -a

override_dh_install-arch:
# sd plugins aren't installed automatically
#	make DESTDIR=$(CURDIR)/debian/tmp -C src/stored install-aligned install-cloud
	dh_install -a
	# create a reference of which database type is installed on the system
	# and create a link to the dbconfig information that is dbtype independent
	$(foreach db,$(VARIANTS), \
		mkdir -p debian/bacula-common-$(db)/usr/share/bacula-common; \
		echo $(db) > debian/bacula-common-$(db)/usr/share/bacula-common/dbtype; \
		ln -s /etc/dbconfig-common/bacula-director-$(db).conf debian/bacula-common-$(db)/usr/share/bacula-common/dbc_database.conf;)
ifeq ($(HAVE_SYSTEMD),1)
	# only install systemd related files if systemd is enabled during build
	install -m 644 platforms/systemd/bacula.conf -D debian/bacula-common/$(TMPFILESDIR)/bacula.conf
	install -m 644 platforms/systemd/bacula-fd.service -D debian/bacula-fd/$(SYSTEMDUNITDIR)/bacula-fd.service
	install -m 644 platforms/systemd/bacula-sd.service -D debian/bacula-sd/$(SYSTEMDUNITDIR)/bacula-sd.service
	install -m 644 platforms/systemd/bacula-dir.service -D debian/bacula-director/$(SYSTEMDUNITDIR)/bacula-director.service
endif

override_dh_installexamples:
# The monitoring plugin in the examples needs to be cleaned, otherwise
# builds will not be reproducible. But only if the makefile exists,
# which it doesn't if we only build-indep.
	@[ -f examples/nagios/check_bacula/Makefile ] && make -C examples/nagios/check_bacula libtool-clean distclean || true
	dh_installexamples

override_dh_installdocs:
# upstream release notes should be installed as "NEWS" (Debian policy 12.7)
	cp -a ReleaseNotes NEWS
	dh_installdocs -pbacula --link-doc=bacula-server
	dh_installdocs -Nbacula-common -Nbacula-client -Nbacula-server -Nbacula-director-mysql -Nbacula-director-sqlite3 -Nbacula-director-pgsql --remaining-packages --link-doc=bacula-common
	dh_installdocs --remaining-packages

# We only need the scripts from src/cats for the arch:all packages.
# Compiling and installing is easier than picking out the scripts to
# install manually
override_dh_auto_build-indep:
	make DESTDIR=$(CURDIR)/debian/tmp -C src/cats
override_dh_auto_install-indep:
	mkdir -p debian/tmp/etc/bacula/scripts
	make DESTDIR=$(CURDIR)/debian/tmp -C src/cats install
	######### dbconfig-common stuff
	# The script install-dbconfig needs to be adapted when upstream changes the database format!
	debian/scripts/install-dbconfig # handles install of all upgrade/install scripts to db version 11 and greater

override_dh_autoreconf:
# save the original files if not already saved
	@[ -f configure -a ! -f debian/configure.dh_autoreconf.save ] && mv configure debian/configure.dh_autoreconf.save || true
	@[ -f autoconf/aclocal.m4 -a ! -f debian/aclocal.m4.dh_autoreconf.save ] && mv autoconf/aclocal.m4 debian/aclocal.m4.dh_autoreconf.save || true
	dh_autoreconf debian/autogen.sh

override_dh_autoreconf_clean:
	dh_autoreconf_clean
# restore the original files if saved
	@[ -f debian/configure.dh_autoreconf.save ] && mv debian/configure.dh_autoreconf.save configure || true
	@[ -f debian/aclocal.m4.dh_autoreconf.save ] && mv debian/aclocal.m4.dh_autoreconf.save autoconf/aclocal.m4 || true

override_dh_auto_configure:
	$(foreach db,$(VARIANTS),$(call db-templates-subst,$(db)))
	# Strange workaround for strange binary path problems in Qt5.9
